<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class MY_Controller extends CI_Controller {

    function __construct()
    {
        parent::__construct();
        
        if (!$this->isUserLoggedIn() )
        {
            redirect(site_url(), 'refresh');
            //echo "failed ", $rep_logged_in; 
        } 
        $this->now = date('Y-m-d H:i:s');
        $this->today = date('Y-m-d');
        $this->time = date('H:i:s');


        
        $this->details = $this->session->userdata('current_userdata');
        $this->privilege = $this->session->userdata('privilege');

        

        //$type = $this->session->userdata('type');
        

        



        
        $this->data = array();
        #GET APP DATA
        $this->data['errors']= '';
        $this->data['appname']= "";
       
        
       
        #GLOBAL VARIABLES FOR PAGE LEVEL STYLES AND SCRIPTS
        $this->data['page_level_styles'] = "";
        $this->data['page_level_scripts'] = "";

        #RUN ANY NEW MIGRATIONS
        $this->load->library('migration');
        $this->migration->current();
    }

    public function isUserLoggedIn(){
        $status=FALSE;
        if($this->session->userdata('isloggedin')){
            $status=$this->session->userdata('isloggedin');    
        }
        return $status;
    }



    public function _is_ajax($link)
    {
        if(!$this->input->is_ajax_request()){

            redirect($link, 'refresh');
        }
        
    }



        #CHECK IF THE URL BELONGS TO A STORE OTHERWISE REDIRECT TO ADMIN
    public function analyzeUrl(){
        if ($this->data['current_url'] == config_item('super_admin_url')) {
            return '';
        }
        else {
            $this->db->where('inv_school_config.url', $this->data['current_url']);
            $this->db->join('tbl_school_config','tbl_school_config.schoolid = inv_school_config.schoolid','inner');
            $query = $this->db->get('inv_school_config');
            if ($query->num_rows()){
                return $query->row();
            }
            else {
                redirect(site_url('Super/Login'));
            }
        }
    }





    public function _get_unique_code($table, $field, $type, $length)
    {
        $new_code = random_string($type, $length);

        $match_code = $this->db->get_where($table, array($field=>$new_code))->row();
        if(count($match_code)==1){
            return $this->_get_unique_code($table, $field, $type, $length);
        }else{
            return $new_code;
        }
    }

    public function _log_sql($statement)
    {
        $this->db->insert('sql_log', ['statements'=>$statement, 'created'=>date('Y-m-d'), 'datecreated'=>$this->now]);
    }

    public function _log_activity($title, $action_details)
    {
        
        $this->logAction($title ,$action_details,$this->details->storeid);
    }



    public function logAction($action_type,$action_details,$storeid=NULL){
        $data = ['action_type'=>$action_type,'action_details'=>$action_details,'shopid'=>$storeid];
        $this->basic->save('activity',$data);
    }

    public function _getPrivilegeString($privilegeArray){
        $privilege = "";
        if(!is_array($privilegeArray)){
            return FALSE;
        }
        else{
            if(in_array('SUPERADMIN', $privilegeArray)){
                $privilege = 'SUPERADMIN';
            }
            else{
                $privilege = implode(',',$privilegeArray);
            }
            return $privilege;
        }
    }

    public function clock_in()
    {
        $check = $this->basic->get_one('clock_in', ['login_date'=>$this->today, 'logouttime !='=>'', 'staffid'=>$this->user_id]);
        if(count($check)){
            redirect('auth/logout','refresh');
        }
    }

}
/* End of file My_Controller.php */
/* Location: ./application/core/My_Controller.php */ ?>